package ast;

import compiler.*;

/**
 * <p>Title: Programming mini project 2 Java-- compiler</p>
 * <p>Description: represents a compound statement</p>
 * <p>Copyright: Copyright (c) 2004 Nicholas Cameron</p>
 * <p>Company: </p>
 * @author Nicholas Cameron
 * @version 1.0
 */

public class CompoundNode extends Node
{
    private ListNode stmts;

    private ScopeSymbol symbol = null;

    public CompoundNode(ListNode stmts, int lineNumber, int colNumber)
    {
        super(lineNumber, colNumber);
        this.stmts = stmts;
    }

    public String toString()
    {
        return "{\n" + stmts + "\n}";
    }

    public Object accept(Visitor v)
    {
        return v.visit(this);
    }

    public void visitChildren(Visitor v)
    {
        if (stmts != null)
            stmts.accept(v);
    }

    public void setSymbol(ScopeSymbol symbol)
    {
        this.symbol = symbol;
    }
    public ScopeSymbol getSymbol()
    {
        return symbol;
    }
}
